USE [GestorGastosBD]
GO

--CALENDARIO
CREATE TABLE [dbo].[Calendario](
	[IdCalendario] [int] IDENTITY(1,1) NOT NULL,
	[FechaFestiva] [datetime] NULL,
 CONSTRAINT [PK_Calendario] PRIMARY KEY CLUSTERED 
(
	[IdCalendario] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--CATEGORIAPROFESIONAL
CREATE TABLE [dbo].[CategoriaProfesional](
	[IdCategoriaProfesional] [int] IDENTITY(1,1) NOT NULL,
	[DescCategoriaProfesional] [varchar](50) NULL,
	[IndBaja] [bit] NULL,
 CONSTRAINT [PK_CategoriaProfesional] PRIMARY KEY CLUSTERED 
(
	[IdCategoriaProfesional] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--DEPARTAMENTO
CREATE TABLE [dbo].[Departamento](
	[IdDepartamento] [int] IDENTITY(1,1) NOT NULL,
	[DescDepartamento] [varchar](50) NULL,
	[IndBaja] [bit] NULL,
 CONSTRAINT [PK_Departamento] PRIMARY KEY CLUSTERED 
(
	[IdDepartamento] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--GASTOTIPO
CREATE TABLE [dbo].[GastoTipo](
	[IdGastoTipo] [int] IDENTITY(1,1) NOT NULL,
	[DescGastoTipo] [varchar](150) NULL,
	[IndImporteLibre] [bit] NULL,
	[IndImporteDiferenteFestivo] [bit] NULL,
	[IndAdjuntarFichero] [bit] NULL,
	[Importe] [decimal](18, 2) NULL,
	[ImporteFestivo] [decimal](18, 2) NULL,
	[IndBaja] [bit] NULL,
 CONSTRAINT [PK_GastoTipo] PRIMARY KEY CLUSTERED 
(
	[IdGastoTipo] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--HOJAESTADOTIPO
CREATE TABLE [dbo].[HojaEstadoTipo](
	[IdHojaEstadoTipo] [int] NOT NULL,
	[DescHojaEstadoTipo] [varchar](255) NULL,
 CONSTRAINT [PK_HojaEstadoTipo] PRIMARY KEY CLUSTERED 
(
	[IdHojaEstadoTipo] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--ROL
CREATE TABLE [dbo].[Rol](
	[IdRol] [int] IDENTITY(1,1) NOT NULL,
	[DescRol] [varchar](255) NULL,
 CONSTRAINT [PK_Rol] PRIMARY KEY CLUSTERED 
(
	[IdRol] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

--USUARIO
CREATE TABLE [dbo].[Usuario](
	[IdUsuario] [int] IDENTITY(1,1) NOT NULL,
	[Nombre] [varchar](50) NULL,
	[Apellido1] [varchar](50) NULL,
	[Apellido2] [varchar](50) NULL,
	[NombreCompleto] [varchar](150) NULL,
	[NIF] [varchar](9) NOT NULL,
	[Email] [varchar](50) NULL,
	[Username] [varchar](20) NULL,
	[Password] [varchar](10) NULL,
	[IdCategoriaProfesional] [int] NULL,
	[IdDepartamento] [int] NULL,
	[IdRol] [int] NULL,
	[IndBaja] [bit] NULL,
 CONSTRAINT [PK_Table_1] PRIMARY KEY CLUSTERED 
(
	[IdUsuario] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Usuario]  WITH CHECK ADD  CONSTRAINT [FK_Usuario_CategoriaProfesional] FOREIGN KEY([IdCategoriaProfesional])
REFERENCES [dbo].[CategoriaProfesional] ([IdCategoriaProfesional])
GO

ALTER TABLE [dbo].[Usuario] CHECK CONSTRAINT [FK_Usuario_CategoriaProfesional]
GO

ALTER TABLE [dbo].[Usuario]  WITH CHECK ADD  CONSTRAINT [FK_Usuario_Departamento] FOREIGN KEY([IdDepartamento])
REFERENCES [dbo].[Departamento] ([IdDepartamento])
GO

ALTER TABLE [dbo].[Usuario] CHECK CONSTRAINT [FK_Usuario_Departamento]
GO

ALTER TABLE [dbo].[Usuario]  WITH CHECK ADD  CONSTRAINT [FK_Usuario_Rol] FOREIGN KEY([IdRol])
REFERENCES [dbo].[Rol] ([IdRol])
GO

ALTER TABLE [dbo].[Usuario] CHECK CONSTRAINT [FK_Usuario_Rol]
GO

--USUARIOSUPERIORREL
CREATE TABLE [dbo].[UsuarioSuperiorRel](
	[IdUsuario] [int] NOT NULL,
	[IdUsuarioSuperior] [int] NOT NULL,
 CONSTRAINT [PK_UsuarioSuperiorRel_1] PRIMARY KEY CLUSTERED 
(
	[IdUsuario] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[UsuarioSuperiorRel]  WITH CHECK ADD  CONSTRAINT [FK_UsuarioSuperiorRel_Usuario] FOREIGN KEY([IdUsuario])
REFERENCES [dbo].[Usuario] ([IdUsuario])
GO

ALTER TABLE [dbo].[UsuarioSuperiorRel] CHECK CONSTRAINT [FK_UsuarioSuperiorRel_Usuario]
GO

ALTER TABLE [dbo].[UsuarioSuperiorRel]  WITH CHECK ADD  CONSTRAINT [FK_UsuarioSuperiorRel_UsuarioSuperior] FOREIGN KEY([IdUsuarioSuperior])
REFERENCES [dbo].[Usuario] ([IdUsuario])
GO

ALTER TABLE [dbo].[UsuarioSuperiorRel] CHECK CONSTRAINT [FK_UsuarioSuperiorRel_UsuarioSuperior]
GO

--HOJA
CREATE TABLE [dbo].[Hoja](
	[IdHoja] [int] IDENTITY(1,1) NOT NULL,
	[Referencia] [varchar](7) NULL,
	[IdHojaEstadoTipo] [int] NULL,
	[Importe] [decimal](18, 2) NULL,
	[FechaCreacion] [datetime] NULL,
	[IdUsuarioCreador] [int] NULL,
	[FechaSupervision] [datetime] NULL,
	[IdUsuarioSupervisor] [int] NULL,
	[IndBaja] [bit] NULL,
	[DesMotivoDenegada] [varchar](1000) NULL,
 CONSTRAINT [PK_Hoja] PRIMARY KEY CLUSTERED 
(
	[IdHoja] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Hoja]  WITH CHECK ADD  CONSTRAINT [FK_Hoja_HojaEstadoTipo] FOREIGN KEY([IdHojaEstadoTipo])
REFERENCES [dbo].[HojaEstadoTipo] ([IdHojaEstadoTipo])
GO

ALTER TABLE [dbo].[Hoja] CHECK CONSTRAINT [FK_Hoja_HojaEstadoTipo]
GO

ALTER TABLE [dbo].[Hoja]  WITH CHECK ADD  CONSTRAINT [FK_Hoja_UsuarioCreador] FOREIGN KEY([IdUsuarioCreador])
REFERENCES [dbo].[Usuario] ([IdUsuario])
GO

ALTER TABLE [dbo].[Hoja] CHECK CONSTRAINT [FK_Hoja_UsuarioCreador]
GO

ALTER TABLE [dbo].[Hoja]  WITH CHECK ADD  CONSTRAINT [FK_Hoja_UsuarioSupervisor] FOREIGN KEY([IdUsuarioSupervisor])
REFERENCES [dbo].[Usuario] ([IdUsuario])
GO

ALTER TABLE [dbo].[Hoja] CHECK CONSTRAINT [FK_Hoja_UsuarioSupervisor]
GO

--GASTO
CREATE TABLE [dbo].[Gasto](
	[IdGasto] [int] IDENTITY(1,1) NOT NULL,
	[IdGastoTipo] [int] NULL,
	[IdHoja] [int] NULL,
	[Fecha] [datetime] NULL,
	[Unidades] [int] NULL,
	[ImporteUnidad] [decimal](18, 2) NULL,
	[ImporteTotal] [decimal](18, 2) NULL,
	[Fichero] [image] NULL,
	[IndBaja] [bit] NULL,
 CONSTRAINT [PK_Gasto] PRIMARY KEY CLUSTERED 
(
	[IdGasto] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

ALTER TABLE [dbo].[Gasto]  WITH CHECK ADD  CONSTRAINT [FK_Gasto_GastoTipo] FOREIGN KEY([IdGastoTipo])
REFERENCES [dbo].[GastoTipo] ([IdGastoTipo])
GO

ALTER TABLE [dbo].[Gasto] CHECK CONSTRAINT [FK_Gasto_GastoTipo]
GO

ALTER TABLE [dbo].[Gasto]  WITH CHECK ADD  CONSTRAINT [FK_Gasto_Hoja] FOREIGN KEY([IdHoja])
REFERENCES [dbo].[Hoja] ([IdHoja])
GO

ALTER TABLE [dbo].[Gasto] CHECK CONSTRAINT [FK_Gasto_Hoja]
GO

