﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using GestorGastos.Administracion.GestorGastosService;

namespace GestorGastos.Administracion
{
    public partial class FormLogin : FormBase
    {
        public FormLogin()
        {
            InitializeComponent();
        }

        private void lnkSalir_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            this.Close();
        }

        private void btnEntrar_Click(object sender, EventArgs e)
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;

                if (!string.IsNullOrEmpty(txtNombre.Text) && !string.IsNullOrEmpty(txtContrasena.Text))
                {
                    GestorGastosServiceClient servicioGG = new GestorGastosServiceClient();

                    UsuarioDTO usuarioConectado = servicioGG.ValidarLoginUsuario(txtNombre.Text, txtContrasena.Text);
                    if (usuarioConectado != null)
                    {
                        if (usuarioConectado.IdRol == (int)RolEnum.ADMINISTRADOR)
                        {
                            this.Visible = false;
                            new MDIFormAdmin(usuarioConectado.IdUsuario).ShowDialog();
                            this.Close();
                        }
                        else
                            MessageBox.Show("El usuario no tiene permisos de administración.", "GestorGastos");
                    }
                    else
                        MessageBox.Show("Datos incorrectos, vuelva a introducirlos.", "GestorGastos");
                }
                else
                {
                    lblNombreUsuarioError.Visible = string.IsNullOrEmpty(txtNombre.Text);
                    lblContrasenaError.Visible = string.IsNullOrEmpty(txtContrasena.Text);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Se ha producido un error: \n" + ex.Message, "GestorGastos");
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }
    }
}