﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using GestorGastos.Administracion.GestorGastosService;

namespace GestorGastos.Administracion
{
    public partial class FormUsuarios : FormBase
    {
        GestorGastosServiceClient servicioGG = new GestorGastosServiceClient();

        int? idUsuarioSelected;
        int idUsuarioConectado;

        public FormUsuarios(int idUsuarioAdmin)
        {
            InitializeComponent();

            dtgUsuarios.AutoGenerateColumns = false;
            idUsuarioConectado = idUsuarioAdmin;
        }

        private void btnBuscar_Click(object sender, EventArgs e)
        {
            Buscar();
        }

        private void dtgUsuarios_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                DataGridViewRow filaSeleccionada = dtgUsuarios.Rows[e.RowIndex];
                idUsuarioSelected = (int)filaSeleccionada.Cells["IdUsuario"].Value;

                //Abrir formulario pasando el IdUsuario
                Form frmUsuarioEdit = new FormUsuarioEdit(idUsuarioSelected, idUsuarioConectado);
                frmUsuarioEdit.ShowDialog();
                Buscar(); 
            }
        }

        private void btnNuevoDepartamento_Click(object sender, EventArgs e)
        {
            //Abrir formulario pasando el IdUsuario
            Form frmUsuarioEdit = new FormUsuarioEdit(null, idUsuarioConectado);
            frmUsuarioEdit.ShowDialog();
        }

        private void btnSalir_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Buscar()
        {
            try
            {
                if (!string.IsNullOrEmpty(txtNIF.Text) || !string.IsNullOrEmpty(txtNombre.Text))
                {
                    List<UsuarioDTO> listaUsuarios = new List<UsuarioDTO>();
                    if (!string.IsNullOrEmpty(txtNIF.Text) && !string.IsNullOrEmpty(txtNombre.Text))
                        listaUsuarios = servicioGG.ObtenerUsuariosPorNIFNombre(txtNIF.Text, txtNombre.Text);
                    else if (!string.IsNullOrEmpty(txtNIF.Text) && string.IsNullOrEmpty(txtNombre.Text))
                        listaUsuarios = servicioGG.ObtenerUsuariosPorNIF(txtNIF.Text);
                    else
                        listaUsuarios = servicioGG.ObtenerUsuariosPorNombre(txtNombre.Text);

                    dtgUsuarios.DataSource = listaUsuarios;
                }
                else
                {
                    this.MostrarInformacion("Debe informar alguno de los campos de búsqueda.");
                    dtgUsuarios.DataSource = null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Se ha producido un error: \n" + ex.Message, "GestorGastos");
            }
        }
    }
}
