﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using GestorGastos.App.GestorGastosService;

namespace GestorGastos.App
{
    public partial class FormDenegacionHoja : Form
    {
        GestorGastosServiceClient servicioGG = new GestorGastosServiceClient();

        int idHojaSeleccionada;
        UsuarioDTO usuarioConectado;

        public FormDenegacionHoja(int idHoja, UsuarioDTO usuario)
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;

            idHojaSeleccionada = idHoja;
            usuarioConectado = usuario;
        }

        private void btnAceptar_Click(object sender, EventArgs e)
        {
            try
            {
                if (!string.IsNullOrEmpty(txtMotivo.Text.Trim()))
                {
                    if (servicioGG.DenegarHoja(idHojaSeleccionada, txtMotivo.Text.Trim(), usuarioConectado.IdUsuario))
                    {
                        new FormAviso("Hoja denegada correctamente.", false).ShowDialog();

                        DialogResult = DialogResult.OK;
                        this.Close();
                    }
                }
                else
                    lblMotivoError.Visible = true;
            }
            catch (Exception ex)
            {
                new FormAviso("ERROR: Contacte con el administrador. \n" + ex.Message, true).ShowDialog();
            }
        }

        private void btnCancelar_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}
