﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using GestorGastos.App.GestorGastosService;

namespace GestorGastos.App
{
    public partial class FormLogin : Form
    {
        public FormLogin()
        {
            InitializeComponent();
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.StartPosition = FormStartPosition.CenterScreen;
            this.ShowInTaskbar = false;
        }

        private void btnEntrar_Click(object sender, EventArgs e)
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;

                if (!string.IsNullOrEmpty(txtNombre.Text) && !string.IsNullOrEmpty(txtContrasena.Text))
                {
                    GestorGastosServiceClient servicioGG = new GestorGastosServiceClient();

                    UsuarioDTO usuarioConectado = servicioGG.ValidarLoginUsuario(txtNombre.Text, txtContrasena.Text);
                    if (usuarioConectado != null)
                    {
                        if (usuarioConectado.IdRol != (int) RolEnum.ADMINISTRADOR)
                        {
                            this.Visible = false;
                            new FormPrincipal(usuarioConectado).ShowDialog();
                            this.Close();
                        }
                        else
                            new FormAviso("El usuario no tiene permisos para acceder a la aplicación.", false).ShowDialog();
                    }
                    else
                        new FormAviso("No se encuentra el usuario. Compruebe los datos.", false).ShowDialog();
                }
                else
                {
                    lblNombreError.Visible = string.IsNullOrEmpty(txtNombre.Text);
                    lblContrasenaError.Visible = string.IsNullOrEmpty(txtContrasena.Text);
                }
            }
            catch (Exception ex)
            {
                new FormAviso("ERROR: Contacte con el administrador. \n" + ex.Message, true).ShowDialog();
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private void lnkSalir_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            this.Close();
        }
    }
}
