﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Data;
using GestorGastos.Model;

namespace GestorGastos.Business
{
    public class CalendarioBL
    {
        public static List<Calendario> GetFestividades()
        {
            return CalendarioDL.GetFestividades();
        }

        public static bool AgregarFestividad(DateTime fecha)
        {
            Calendario calendario = CalendarioDL.GetCalendarioByFecha(fecha);
            if (calendario == null)
            {
                calendario = new Calendario();
                calendario.FechaFestiva = fecha;
                CalendarioDL.AddCalendario(calendario);
                return true;
            }
            else
                return false;
        }

        public static void EliminarFecha(int idCalendario)
        {
            Calendario calendario = CalendarioDL.GetCalendario(idCalendario);
            if (calendario != null)
                CalendarioDL.RemoveCalendario(calendario);
        }

        public static bool EsFechaFestiva(DateTime fecha)
        {
            return CalendarioDL.GetCalendarioByFecha(fecha) != null;
        }
    }
}
