﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Model;
using GestorGastos.Data;

namespace GestorGastos.Business
{
    public class CategoriaProfesionalBL
    {
        public static List<CategoriaProfesional> GetCategorias()
        {
            return CategoriaProfesionalDL.GetCategorias();
        }

        public static CategoriaProfesional GetCategoria(int idCategoria)
        {
            return CategoriaProfesionalDL.GetCategoria(idCategoria);
        }

        public static void ActualizarCategoria(CategoriaProfesional categoria)
        {
            CategoriaProfesional categoriaBD = GetCategoria(categoria.IdCategoriaProfesional);
            categoria.IndBaja = false;

            if (categoriaBD == null)
                CategoriaProfesionalDL.AddCategoria(categoria);
            else
                CategoriaProfesionalDL.UpdateCategoria(categoria);
        }

        /// <summary>
        ///  Baja lógica de la categoría. Si tiene empleados quedarán sin asignar a categoría
        /// </summary>
        /// <param name="idCategoria"></param>
        public static void EliminarCategoria(int idCategoria)
        {
            List<Usuario> lstUsuariosCategoria= UsuarioBL.GetUsuariosByIdCategoria(idCategoria);
            foreach (Usuario usuario in lstUsuariosCategoria)
            {
                usuario.IdCategoriaProfesional = null;
                UsuarioBL.ActualizarUsuario(usuario);
            }

            CategoriaProfesional categoriaBD = GetCategoria(idCategoria);
            if (categoriaBD != null)
            {
                categoriaBD.IndBaja = true;
                CategoriaProfesionalDL.UpdateCategoria(categoriaBD);
            }
        }
    }
}
