﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Model;
using GestorGastos.Data;

namespace GestorGastos.Business
{
    public class DepartamentoBL
    {
        public static List<Departamento> GetDepartamentos()
        {
            return DepartamentoDL.GetDepartamentos();
        }

        public static Departamento GetDepartamento(int idDepartamento)
        {
            return DepartamentoDL.GetDepartamento(idDepartamento);
        }

        public static void ActualizarDepartamento(Departamento departamento)
        {
            Departamento departamentoBD = GetDepartamento(departamento.IdDepartamento);
            departamento.IndBaja = false;

            if (departamentoBD == null)
                DepartamentoDL.AddDepartamento(departamento);
            else
                DepartamentoDL.UpdateDepartamento(departamento);
        }

        /// <summary>
        /// Baja lógica del departamento. Si tiene empleados quedarán sin asignar a departamento
        /// </summary>
        /// <param name="idDepartamento"></param>
        public static void EliminarDepartamento(int idDepartamento)
        {
            List<Usuario> lstUsuariosDepartamento = UsuarioBL.GetUsuariosByIdDepartamento(idDepartamento);
            foreach (Usuario usuario in lstUsuariosDepartamento)
            {
                usuario.IdDepartamento = null;
                UsuarioBL.ActualizarUsuario(usuario);
            }

            Departamento departamentoBD = GetDepartamento(idDepartamento);
            if (departamentoBD != null)
            {
                departamentoBD.IndBaja = true;
                DepartamentoDL.UpdateDepartamento(departamentoBD);
            }
        }
    }
}
