﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Data;
using GestorGastos.Model;

namespace GestorGastos.Business
{
    public class GastoTipoBL
    {
        public static List<GastoTipo> GetGastosTipos()
        {
            return GastoTipoDL.GetGastosTipos();
        }

        public static GastoTipo GetGastoTipo(int idGastoTipo)
        {
            return GastoTipoDL.GetGastoTipo(idGastoTipo);
        }

        public static void ActualizarGastoTipo(GastoTipo gastoTipo)
        {
            GastoTipo gastoTipoBD = GetGastoTipo(gastoTipo.IdGastoTipo);
            gastoTipo.IndBaja = false;

            if (gastoTipoBD == null)
                GastoTipoDL.AddGastoTipo(gastoTipo);
            else
                GastoTipoDL.UpdateGastoTipo(gastoTipo);
        }

        /// <summary>
        /// Baja lógica 
        /// </summary>
        /// <param name="idGastoTipo"></param>
        public static void EliminarGastoTipo(int idGastoTipo)
        {
            GastoTipo gastoTipoBD = GetGastoTipo(idGastoTipo);
            if (gastoTipoBD != null)
            {
                gastoTipoBD.IndBaja = true;
                GastoTipoDL.UpdateGastoTipo(gastoTipoBD);
            }
        }

    }
}

