﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Model;

namespace GestorGastos.Data
{
    public class CalendarioDL
    {
        private GestorGastosBDEntities contexto;

        public CalendarioDL()
        {
            contexto = new GestorGastosBDEntities();
        }

        public static Calendario GetCalendario(int idCalendario)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var r = from c in contexto.Calendarios
                        where c.IdCalendario == idCalendario
                        select c;
                if (r.Count<Calendario>() > 0)
                    return r.First();
                else
                    return null;
            }
        }

        public static Calendario GetCalendarioByFecha(DateTime fecha)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var r = from c in contexto.Calendarios
                        where c.FechaFestiva == fecha 
                        select c;
                if (r.Count<Calendario>() > 0)
                    return r.First();
                else
                    return null;
            }
        }

        public static List<Calendario> GetFestividades()
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var lc = from c in contexto.Calendarios
                         orderby c.FechaFestiva 
                         select c;
                return lc.ToList();
            }
        }

        public static void AddCalendario(Calendario calendario)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Calendarios.Add(calendario);
                contexto.SaveChanges();
            }
        }

        public static void RemoveCalendario(Calendario calendario)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Calendarios.Attach(calendario);
                contexto.Calendarios.Remove(calendario);
                contexto.SaveChanges();
            }
        }
    }
}
