﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GestorGastos.Model;

namespace GestorGastos.Data
{
    public class CategoriaProfesionalDL
    {
        private GestorGastosBDEntities contexto;

        public CategoriaProfesionalDL()
        {
            contexto = new GestorGastosBDEntities();
        }

        public static List<CategoriaProfesional> GetCategorias()
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var ld = from d in contexto.CategoriaProfesionales
                         where d.IndBaja == false
                         orderby d.DescCategoriaProfesional
                         select d;
                return ld.ToList();
            }
        }

        public static CategoriaProfesional GetCategoria(int idCategoria)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var ld = from d in contexto.CategoriaProfesionales
                         where d.IdCategoriaProfesional == idCategoria
                         select d;
                if (ld.Count<CategoriaProfesional>() > 0)
                    return ld.First();
                else
                    return null;
            }
        }

        public static void UpdateCategoria(CategoriaProfesional categoria)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {

                contexto.CategoriaProfesionales.Attach(categoria);
                contexto.Entry(categoria).State = EntityState.Modified;
                contexto.SaveChanges();
            }
        }

        public static void AddCategoria(CategoriaProfesional categoria)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.CategoriaProfesionales.Add(categoria);
                contexto.SaveChanges();
            }
        }

        public static void RemoveCategoria(CategoriaProfesional categoria)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.CategoriaProfesionales.Attach(categoria);
                contexto.CategoriaProfesionales.Remove(categoria);
                contexto.SaveChanges();
            }
        }
    }
}
