﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Model;

namespace GestorGastos.Data
{
    public class DepartamentoDL
    {
        private GestorGastosBDEntities contexto;

        public DepartamentoDL()
        {
            contexto = new GestorGastosBDEntities();
        }

        public static List<Departamento> GetDepartamentos()
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var ld = from d in contexto.Departamentos
                         where d.IndBaja == false
                         orderby d.DescDepartamento
                         select d;
                return ld.ToList();
            }
        }

        public static Departamento GetDepartamento(int idDepartamento)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var ld = from d in contexto.Departamentos
                         where d.IdDepartamento == idDepartamento
                         select d;
                if (ld.Count<Departamento>() > 0)
                    return ld.First();
                else
                    return null;
            }
        }

        public static void UpdateDepartamento(Departamento departamento)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {

                contexto.Departamentos.Attach(departamento);
                contexto.Entry(departamento).State = EntityState.Modified;
                contexto.SaveChanges();
            }
        }

        public static void AddDepartamento(Departamento departamento)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Departamentos.Add(departamento);
                contexto.SaveChanges();
            }
        }

        public static void RemoveDepartamento(Departamento departamento)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Departamentos.Attach(departamento);
                contexto.Departamentos.Remove(departamento);
                contexto.SaveChanges();
            }
        }
    }
}
