﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GestorGastos.Model;

namespace GestorGastos.Data
{
    public class GastoDL
    {
        private GestorGastosBDEntities contexto;

        public GastoDL()
        {
            contexto = new GestorGastosBDEntities();
        }

        public static List<Gasto> GetGastosByIdHoja(int idHoja)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var lg = from g in contexto.Gastos
                         where g.IdHoja == idHoja && g.IndBaja == false
                         select g;
                return lg.ToList();
            }
        }

        public static Gasto GetGasto(int idGasto)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var lg = from g in contexto.Gastos
                         where g.IdGasto == idGasto
                         select g;
                if (lg.Count<Gasto>() > 0)
                    return lg.First();
                else
                    return null;
            }
        }

        public static void AddGasto(Gasto gasto)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Gastos.Add(gasto);
                contexto.SaveChanges();
            }
        }

        public static void UpdateGasto(Gasto gasto)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.Gastos.Attach(gasto);
                contexto.Entry(gasto).State = EntityState.Modified;
                contexto.SaveChanges();
            }
        }

      
    }
}
