﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using GestorGastos.Model;

namespace GestorGastos.Data
{
    public class GastoTipoDL
    {
        private GestorGastosBDEntities contexto;

        public GastoTipoDL()
        {
            contexto = new GestorGastosBDEntities();
        }

        public static List<GastoTipo> GetGastosTipos()
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var lc = from g in contexto.GastoTipos
                         where g.IndBaja == false
                         orderby g.DescGastoTipo
                         select g;
                return lc.ToList();
            }
        }

        public static GastoTipo GetGastoTipo(int idGastoTipo)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                var lg = from g in contexto.GastoTipos
                         where g.IdGastoTipo == idGastoTipo
                         select g;
                if (lg.Count<GastoTipo>() > 0)
                    return lg.First();
                else
                    return null;
            }
        }

        public static void UpdateGastoTipo(GastoTipo gastoTipo)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {

                contexto.GastoTipos.Attach(gastoTipo);
                contexto.Entry(gastoTipo).State = EntityState.Modified;
                contexto.SaveChanges();
            }
        }

        public static void AddGastoTipo(GastoTipo gastoTipo)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.GastoTipos.Add(gastoTipo);
                contexto.SaveChanges();
            }
        }

        public static void RemoveGastoTipo(GastoTipo gastoTipo)
        {
            using (GestorGastosBDEntities contexto = new GestorGastosBDEntities())
            {
                contexto.GastoTipos.Attach(gastoTipo);
                contexto.GastoTipos.Remove(gastoTipo);
                contexto.SaveChanges();
            }
        }
    }
}
