﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace GestorGastosWCFServiceLibrary
{
    [ServiceContract]
    public interface IGestorGastosService
    {
        #region Calendario
        [OperationContract]
        List<CalendarioDTO> ObtenerFestividades();

        [OperationContract]
        bool AgregarFestividad(DateTime fecha);

        [OperationContract]
        void EliminarFecha(int idCalendario);

        [OperationContract]
        bool EsFechaFestiva(DateTime fecha);
        #endregion

        #region GastoTipo
        [OperationContract]
        List<GastoTipoDTO> ObtenerGastosTipos();

        [OperationContract]
        GastoTipoDTO ObtenerGastoTipo(int idGastoTipo);

        [OperationContract]
        void ActualizarGastoTipo(GastoTipoDTO gastoTipoDTO);

        [OperationContract]
        void EliminarGastoTipo(int idGastoTipo);
        #endregion

        #region Departamento
        [OperationContract]
        List<DepartamentoDTO> ObtenerDepartamentos();

        [OperationContract]
        DepartamentoDTO ObtenerDepartamento(int idDepartamento);

        [OperationContract]
        void ActualizarDepartamento(DepartamentoDTO departamentoDTO);

        [OperationContract]
        void EliminarDepartamento(int idDepartamento);
        #endregion

        #region CategoriaProfesional
        [OperationContract]
        List<CategoriaProfesionalDTO> ObtenerCategorias();

        [OperationContract]
        CategoriaProfesionalDTO ObtenerCategoria(int idCategoria);

        [OperationContract]
        void ActualizarCategoria(CategoriaProfesionalDTO categoriaDTO);

        [OperationContract]
        void EliminarCategoria(int idCategoria);
        #endregion

        #region Usuario
        [OperationContract]
        List<UsuarioDTO> ObtenerUsuariosPorNIFNombre(string NIF, string nombre);

        [OperationContract]
        List<UsuarioDTO> ObtenerUsuariosPorNIF(string NIF);

        [OperationContract]
        List<UsuarioDTO> ObtenerUsuariosPorNombre(string nombre);

        [OperationContract]
        UsuarioDTO ObtenerUsuario(int idUsuario);

        [OperationContract]
        List<UsuarioDTO> ObtenerUsuariosSupervisores();

        [OperationContract]
        void ActualizarUsuario(UsuarioDTO usuarioDTO);

        [OperationContract]
        void RehabilitarUsuario(UsuarioDTO usuarioDTO);

        [OperationContract]
        void InsertarUsuario(UsuarioDTO usuarioDTO);

        [OperationContract]
        void EliminarUsuario(int idUsuario);

        [OperationContract]
        UsuarioDTO ValidarLoginUsuario(string username, string password);

        [OperationContract]
        UsuarioDTO ObtenerUsuarioPorUsername(string username);
        #endregion

        #region Rol
        [OperationContract]
        List<RolDTO> ObtenerRoles();
        #endregion

        #region Hoja
        [OperationContract]
        List<HojaDTO> ObtenerHojasUsuario(int idUsuario);

        [OperationContract]
        List<HojaEstadoTipoDTO> ObtenerHojaEstadoTipos();

        [OperationContract]
        List<HojaDTO> ObtenerHojasUsuarioByEstado(int idUsuario, int idHojaEstadoTipo);

        [OperationContract]
        HojaDTO ObtenerHoja(int idHoja);

        [OperationContract]
        HojaDTO ObtenerHojaPorUsuario(int idHoja, int idUsuario);

        [OperationContract]
        bool EliminarHoja(int idHoja);

        [OperationContract]
        bool AprobarHoja(int idHoja, int idUsuarioSupervisor);

        [OperationContract]
        bool DenegarHoja(int idHoja, string motivo, int idUsuarioSupervisor);

        [OperationContract]
        List<HojaDTO> ObtenerHojasASupervisar(int? idUsuarioSupervisor, int? idHojaEstadoTipo, string nif, string nombre);

        [OperationContract]
        HojaDTO ObtenerHojaVigente(int idUsuario);
        #endregion

        #region Gasto
        [OperationContract]
        List<GastoDTO> ObtenerGastosDeHoja(int idHoja);
        
        [OperationContract]
        GastoDTO ObtenerGastoPorUsuario(int idGasto, int idUsuario);

        [OperationContract]
        void ActualizarGasto(GastoDTO gastoDTO, int idUsuario);

        [OperationContract]
        bool EliminarGasto(int idGasto);
        #endregion
    }
}
